
% here the Lin and Trusler (2012) sound speeds vs P and T are fit 
LT=LT_data;  % this function returns the LT data set.

% chose number of control points for P and T and determine grid (try
% different numbers of control points)
npc=100;
ntc=100;
Xc=linspace(0,500,npc);
Yc=linspace(240,500,ntc);

% set lambda for P and T regularization (example sets them equal) 
% The value given below was adjusted to achieve a reduced chi square of about 1
lam=65*[1 1];

% number of regularization points for every control point
RegFac=[1 1]; 

% order of fit (4 is minimum for "smooth" fit)
Ordr=[4 4];


% derivative to make small
mdrv=[2 2];

% do the fit
% since data are scattered, input X is a matrix with as many columns as
% independent variables
tic
sp2=spdft(LT(:,1:2),LT(:,3),LT(:,4),{Xc,Yc},lam,RegFac,Ordr,mdrv,[]);
toc

%examine fit with plots
txt=sprintf('rms misfit = %5.2f chisqr = %5.2f',sp2.Data.rms,sp2.Data.chisqr);
figsz=[1 .9*scrsz(4) 1.5*scrsz(3)/4 .9*scrsz(4)];
h=figure('Name','Two Independent Variable','Position',figsz);
colormap gray

subplot(211)
fnplt(sp2)
shading 'flat'
hold on
plot3(LT(:,1),LT(:,2),LT(:,3),'ko','MarkerFaceColor','k')
xlabel('Pressure (MPa)')
ylabel('Temperature (K)')
hold off
title('Sound Speeds')

subplot(212)
plot3(LT(:,1),LT(:,2),1e2*(sp2.Data.devs)./LT(:,3),'ko','MarkerFaceColor','k')
xlabel('Pressure (MPa)')
ylabel('Temperature (K)')
zlabel('deviations (%)')
title(txt)
grid on